#include <ros/ros.h>
#include <geometry_msgs/Point.h>
//#include <sensor_msgs/PointCloud2.h>


#include <pcl/io/pcd_io.h>
#include <pcl/point_types.h>
#include <pcl/filters/extract_indices.h>
#include <pcl/filters/conditional_removal.h>
#include <pcl_ros/point_cloud.h>

#include <pcl/features/feature.h>

//#include <pcl/kdtree/kdtree.h>
//#include <pcl/segmentation/extract_clusters.h>


#include <boost/make_shared.hpp>

#include <math.h>


#define X_THRESHOLD .5//.12
#define Y_THRESHOLD .4//.12
#define Z_THRESHOLD .5//.12
//#define RADIUS .2
//#define RADIUS2 .02 //has to be atleast .02

//#define PI 3.14159265


geometry_msgs::Point center_pos = geometry_msgs::Point();

ros::Publisher cloud_pub;
ros::Subscriber cloud_sub;

//sensor_msgs::PointCloud2 fullcloud_;
pcl::PointCloud<pcl::PointXYZRGB> input_cloud;
pcl::PointCloud<pcl::PointXYZRGB> output_cloud;
//sensor_msgs::PointCloud2 cloud;




void process_data() {

	//double starttime = ros::Time::now().toSec();
	
	//pcl::PointCloud<pcl::PointXYZRGB> handcloud_square;
	
	
	// find indices to extract ~50ms
	std::vector<int> inds;
	for (uint i = 0; i < input_cloud.points.size(); i++) {
		if ((input_cloud.points[i].x>center_pos.x-X_THRESHOLD && input_cloud.points[i].x<center_pos.x+X_THRESHOLD) &&
				(input_cloud.points[i].y>center_pos.y-Y_THRESHOLD && input_cloud.points[i].y<center_pos.y+Y_THRESHOLD) &&
				(input_cloud.points[i].z>center_pos.z-Z_THRESHOLD && input_cloud.points[i].z<center_pos.z+Z_THRESHOLD)) {
			inds.push_back(i);
		}
	}

	// extract the box points
	pcl::ExtractIndices<pcl::PointXYZRGB> extract;
	extract.setInputCloud(input_cloud.makeShared()); //replace with the ::Ptr variables if it doesnt work
	extract.setIndices(boost::make_shared<std::vector<int> > (inds));
	extract.setNegative(false);
	extract.filter(output_cloud); //same as for setinputcloud
	// makes the display nicer
	//extract.setNegative(true);
	//extract.filter(fullcloud);
	
	/*double tottime = ros::Time::now().toSec() - starttime;
	std::cout << "1 TOTAL TIME = " << tottime << std::endl;
	starttime = ros::Time::now().toSec();*/
	
	
	
	//pcl::toROSMsg(handcloud, rhcloud);
	cloud_pub.publish(output_cloud);
	//std::cout << "input size=" << input_cloud.points.size() << std::endl;
	//std::cout << "output size=" << output_cloud.points.size() << std::endl;
		
}


void cloudcb(const pcl::PointCloud<pcl::PointXYZRGB>::ConstPtr &msg) {
//void cloudcb(const sensor_msgs::PointCloud2ConstPtr &msg) {
	input_cloud = *msg;
	process_data();
	//pcl::fromROSMsg(*msg, fullcloud);
	//std::cout << "received new cloud " << std::setprecision(16) << fullcloud.header.stamp << std::endl;
}

int main(int argc, char* argv[]) {

	ros::init(argc, argv, "kinect_roi");

	ros::NodeHandle n;
	
	center_pos.x = 0.05;
	center_pos.y = 0.1;
	center_pos.z = 1.9;
	
	cloud_sub = n.subscribe<pcl::PointCloud<pcl::PointXYZRGB> > ("/camera/depth_registered/points", 1, cloudcb);
	//cloud_pub = n.advertise<sensor_msgs::PointCloud2> ("/kinect/roi_points", 1);
	cloud_pub = n.advertise<pcl::PointCloud<pcl::PointXYZRGB> > ("/kinect/roi_points", 1);

	ros::spin();

	return 0;
}
